#include <iostream>
#include <queue>

using namespace std;

int capacity[2002][2002];
int res_capacity[2002][2002];
int flow[2002][2002];
int parent[2002];
int min_capacity[2002];
int n,s,t,nv;
int Q[2002];
int Qf, Qb;

int min(int a, int b)
{
    if (a<b)
      return a;
    else
      return b;  
}
int BFS()
{
    
    int i,u;
    for (i=0;i<=nv-1;i++)
    {
      parent[i] = -1;
      min_capacity[i] = INT_MAX;
    } 
    parent[s] = -2;
    Q[1] = s;
    Qf = 1;
    Qb = 1;
    while ((Qf-Qb) >=  0)
    {
       u = Q[Qb];
       Qb++;
       for (i=0;i<=nv-1;i++)
         if ( (i != u) && (parent[i] == -1) && (res_capacity[u][i]>0))
           {
             min_capacity[i] = min(min_capacity[u], res_capacity[u][i]);
             parent[i] = u;
             
             if (i == t)
               return 1;
              
             Qf++;
             Q[Qf] = i;
           }
          
    }
    
    return 0;
}

int maxflow()
{  
   int max_flow = 0; 
   while (BFS() >0 )
   {
      
      max_flow = max_flow + min_capacity[t];
      int u,v;
      v=t;
      while (v!= s)
      {
         u = parent[v];
         flow[u][v] = flow[u][v] + min_capacity[t];
         flow[v][u] = flow[v][u] - min_capacity[t];
         res_capacity[u][v] = res_capacity[u][v] - min_capacity[t];
         res_capacity[v][u] = res_capacity[v][u] + min_capacity[t];
         v = u;   
      }   
   }
   return max_flow;
}


int main()
{
  int i,j, u1, v1, c, m; 
  int vhr[2002];
  int izhr[2002]; 
  cin >> nv >> n;
  s=0;   // 
  t=nv+1; //  
  
  for (i=1;i<=nv;i++)
  {
      vhr[i]=0;
      izhr[i]=0;
  }
  
  //     
  for (i=0;i<=nv+1;i++)
    for (j=0;j<=nv+1;j++)
      {
          capacity[i][j] = 0;
          res_capacity[i][j] = 0;
          flow[i][j] = 0;
      } 
  for (i=1;i<=n;i++)
  {
      cin >> u1 >> v1 >> c;
      izhr[u1]++; vhr[v1]++;
      capacity[u1][v1] = c;
      res_capacity[u1][v1] = c;
  }
 
  
  //           
  //   
  
  for (i=1; i<=nv; i++)
    {if (vhr[i] == 0 )
      {                //
        capacity[s][i] = INT_MAX;
        res_capacity[s][i] = INT_MAX;
        
      }
      if (izhr[i] == 0)
      {                //
        capacity[i][t] = INT_MAX;
        res_capacity[i][t] = INT_MAX;
        
      }
    }  
  nv = nv+2;  
  
  m = maxflow();
  
  cout << m << endl;
  //system ("pause");       
  return 0;
}
